package org.xtext.example.mydsl;

import org.eclipse.xtext.common.services.DefaultTerminalConverters;
import org.eclipse.xtext.conversion.IValueConverter;
import org.eclipse.xtext.conversion.ValueConverter;
import org.eclipse.xtext.conversion.ValueConverterException;
import org.eclipse.xtext.nodemodel.INode;

import edu.kit.ipd.descartes.mm.repository.PrimitiveTypeEnum;

public class PrimitiveTypeConverter extends DefaultTerminalConverters {
	 @ValueConverter(rule = "PrimitiveTypeEnum")
	    public IValueConverter<PrimitiveTypeEnum> ElementBound() {
	        return new IValueConverter<PrimitiveTypeEnum>() {
	        	
	            public PrimitiveTypeEnum toValue(String string, INode node) {
	                if (string == null)
	                    throw new ValueConverterException("Couldn't convert empty string to int", node, null);
	                try {
	                    return Enum.valueOf(PrimitiveTypeEnum.class, string);
	                } catch (NumberFormatException e) {
	                    throw new ValueConverterException("Couldn't convert '"+string+"' to int", node,e);
	                }
	               
	            }

				@Override
				 public String toString(PrimitiveTypeEnum value) {
	                return value.toString();
	            }
	        };
	 }
}